SET NOCOUNT ON;

CREATE DATABASE testvol
ON PRIMARY (
  NAME = N'testvol', 
  FILENAME = N'D:\MSSQL\MSSQL10_50.SQL01\MSSQL\DATA\testvol.mdf',
  SIZE = 200MB,
  MAXSIZE = UNLIMITED,
  FILEGROWTH = 200MB
)
LOG ON (
  NAME = N'testvol_log', 
  FILENAME = N'D:\MSSQL\MSSQL10_50.SQL01\MSSQL\DATA\testvol_log.ldf', 
  SIZE = 100MB, 
  MAXSIZE = UNLIMITED, 
  FILEGROWTH = 100MB
)
GO

ALTER DATABASE [testvol] SET RECOVERY SIMPLE 
GO

USE testvol
GO
CREATE TABLE dbo.measuresData (
  measureId   int NOT NULL PRIMARY KEY CLUSTERED,
  deviceId    int NOT NULL,
  stateId     int NOT NULL,
  groupId     int NOT NULL,
  measureDate datetime NOT NULL,
  intVal      int NOT NULL,
  floatVal    float NOT NULL
)
GO

PRINT 'Starting fill database: ' + convert(nvarchar(32), getdate(), 120);
DECLARE @maxLines int = 10000000;
DECLARE @progressStep int = @maxLines / 100;
DECLARE @devicesCount int = @maxLines / 5;
DECLARE @batchSize int = 10;
DECLARE @i int = 1;
BEGIN TRANSACTION;
WHILE @i <= @maxLines BEGIN 
  INSERT INTO dbo.measuresData (
    measureId,
    deviceId,
    stateId,
    groupId,
    measureDate,
    intVal,
    floatVal
  )
  VALUES (
    @i,
    floor(rand() * @devicesCount + 1),
    floor(rand() * 2 + 1),
    floor(rand() * 100 + 1),
    getdate(),
    floor(rand() * 2000000 - 1000000),
    rand() * 2000000 - 1000000
  );

  if @i % @progressStep = 0 BEGIN
    PRINT convert(nvarchar(16), @i) + ';' + convert(nvarchar(32), getdate(), 120);
  END
  if @i % @batchSize = 0 BEGIN
    COMMIT TRANSACTION;
    BEGIN TRANSACTION;
  END
  SET @i = @i + 1;
END
COMMIT TRANSACTION;
PRINT 'Finished at: ' + convert(nvarchar(32), getdate(), 120);
GO
